<?xml version="1.0"?>
<!--
    This xslt creates numbering.xml
    @cvsid $Id: numbering.xsl,v 1.1 2010/04/13 04:30:09 yfeng Exp $ 
    @author Christine Feng 
-->
<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
  xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
  xmlns:v="urn:schemas-microsoft-com:vml"
  xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
  xmlns:w10="urn:schemas-microsoft-com:office:word"
  xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
  xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
  xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
  xmlns:ct="http://schemas.openxmlformats.org/package/2006/content-types"
  xmlns:fn="http://www.pageseeder.com/function" xmlns:dec="java:java.net.URLDecoder"
  exclude-result-prefixes="#all">


  <xsl:template match="/" mode="content-types">
    <xsl:param name="current-document"/>
    <xsl:for-each select="*">
       <Types xmlns="http://schemas.openxmlformats.org/package/2006/content-types">
        <Override PartName="/word/document.xml" ContentType="application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml"/>
          <xsl:if test="$configDoc/config/comments/@generate = 'true'">
          <Override PartName="/word/comments.xml"
            ContentType="application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml" /> 
          </xsl:if>
       <xsl:for-each select="*">
        <xsl:if test=".[name() = 'Default']">          
          <xsl:copy-of select="." />
        </xsl:if> 
        <xsl:if test=".[name() = 'Override'][@PartName != '/word/document.xml'][@PartName != '/word/comments.xml']">
          <xsl:copy-of select="." />
        </xsl:if>  
        </xsl:for-each>
        <xsl:for-each select="distinct-values($current-document//image/upper-case(substring-after(@src,'.')))">
          <Default ContentType="{concat('image/',.)}" Extension="{.}"/>
        </xsl:for-each>  
    </Types>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="create-documents">
    <xsl:result-document href="{concat($_outputfolder,encode-for-uri('[Content_Types].xml'))}">
    <xsl:apply-templates select="document($_contenttypestemplate)" mode="content-types">
      <xsl:with-param name="current-document" select="current()"/>
    </xsl:apply-templates>
  </xsl:result-document>
  
  <xsl:result-document href="{concat($_outputfolder,'/_rels/.rels')}">
    <xsl:apply-templates select="document(concat($_dotxfolder,'/_rels/.rels'))" mode="copy"/>
  </xsl:result-document>
  
  
  <xsl:for-each select="document($_contenttypestemplate)/ct:Types/ct:Override">
    <xsl:choose>
      <xsl:when test="matches(@PartName,'(/word/document.xml|/word/numbering.xml|/word/styles.xml|/word/comments.xml|word/_rels/comments.xml.rels)')">
       </xsl:when>
      <xsl:otherwise>
        <xsl:result-document href="{concat($_outputfolder,@PartName)}">
          <xsl:apply-templates select="document(concat($_dotxfolder,encode-for-uri(@PartName)))" mode="copy"/>
        </xsl:result-document>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:for-each>
  
  
  <xsl:result-document href="{concat($_outputfolder,'word/_rels/document.xml.rels')}">
      <Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">

        <xsl:for-each select="document($_documentrelationship)//*">
          <xsl:copy-of select=".[name() = 'Relationship'][@Target!='comments.xml']"></xsl:copy-of>
        </xsl:for-each>
        
        <xsl:if test="$configDoc/config/comments/@generate = 'true'">
          <Relationship Id="{concat('rId',(count(document($_documentrelationship)//*[name() = 'Relationship']) + 1))}" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/comments" Target="comments.xml"/>
        </xsl:if>
          
        <xsl:for-each select="//image"> 
          <Relationship Id="{concat('rId',(count(document($_documentrelationship)//*[name() = 'Relationship']) + 1 + position()))}" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/image" Target="{concat('media/',@src)}"/>
        </xsl:for-each>
      </Relationships>   
    </xsl:result-document>

  <xsl:result-document href="{concat($_outputfolder,'word/numbering.xml')}">
    <xsl:if test="$numberingTemplate != ''">
      <xsl:apply-templates select="document(concat($_dotxfolder,$numberingTemplate))" mode="numbering"/>
    </xsl:if>
  </xsl:result-document>
    
    
    <xsl:result-document href="{concat($_outputfolder,'word/styles.xml')}">
    <xsl:apply-templates select="document(concat($_dotxfolder,$stylesTemplate))" mode="styles">
      <xsl:with-param name="inlinelabels" select="$inlinelabels" as="element()"/>
      <xsl:with-param name="blocklabels" select="$blocklabels" as="element()"/>
    </xsl:apply-templates>    
  </xsl:result-document>
  
  <xsl:if test="$configDoc/config/comments/@generate = 'true'">
    <xsl:result-document href="{concat($_outputfolder,'word/comments.xml')}">
      <w:comments>
      <xsl:for-each select=".//section">
           
           <xsl:variable name="id" select="position()"/>
           <xsl:variable name="realsection-id">
            <xsl:variable name="match">
             <xsl:for-each select="ancestor::document[@id]">
                  <xsl:value-of select="concat(./@id,'-')" />
             </xsl:for-each>
            </xsl:variable>
            <xsl:analyze-string regex="({if ($match != '') then $match else '-'})"
                      select="./@id">
                      <xsl:matching-substring>
                      </xsl:matching-substring>
                      <xsl:non-matching-substring>
                        <xsl:value-of select="." />
                      </xsl:non-matching-substring>
                    </xsl:analyze-string> 
           </xsl:variable>   
           <xsl:variable name="filename">
             <xsl:value-of select="./ancestor::document[1]/uri/displaytitle"/>
           </xsl:variable> 
        <w:comment w:id="{$id}" w:initials="PS" >
          <w:p>
            <w:pPr>
              <w:pStyle w:val="CommentReference"/>
            </w:pPr>
            <w:r>
              <w:rPr>
                <w:rStyle w:val="CommentReference"/>
              </w:rPr>
              <w:annotationRef/>
              <w:t>File:<xsl:value-of select="$filename"/></w:t><w:br />
              <w:t>Section:<xsl:value-of select="$realsection-id"/></w:t><w:br />
              
            </w:r>
            <w:hyperlink r:id="{concat('rId',$id)}">
               <w:r>
                 <w:rPr>
                   <w:rStyle w:val="Hyperlink"/>
                 </w:rPr>
                 <w:t>Comment by email</w:t>
               </w:r>
              </w:hyperlink>
          </w:p>
        </w:comment>
      </xsl:for-each>
      </w:comments>   
    </xsl:result-document>
  
    <xsl:result-document href="{concat($_outputfolder,'word/_rels/comments.xml.rels')}">
      <Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">
      <xsl:for-each select=".//section">         
           <xsl:variable name="id" select="position()"/>
           <xsl:variable name="documenturi" select="./ancestor::document[1]/@id"/>         
           <xsl:variable name="documenthost" select="./ancestor::document[1]/documentinfo/uri/@host"/>         
           <xsl:variable name="realsection-id">
            <xsl:variable name="match">
             <xsl:for-each select="ancestor::document">
                  <xsl:value-of select="concat(./documentinfo/uri/@id,'-')" />
             </xsl:for-each>
             <xsl:if test="count(ancestor::document) = 0">
              <xsl:text>-</xsl:text>
             </xsl:if>
            </xsl:variable>
  
            <xsl:analyze-string regex="({$match})"
                      select="./@id">
                      <xsl:matching-substring>
                      </xsl:matching-substring>
                      <xsl:non-matching-substring>
                        <xsl:value-of select="." />
                      </xsl:non-matching-substring>
                    </xsl:analyze-string> 
           </xsl:variable>          
           <xsl:variable name="mailto">
             <xsl:value-of select="concat('mailto:',$documenturi,'-',$realsection-id,'@',$documenthost)"/>
           </xsl:variable>  
                
           <Relationship Id="{concat('rId',$id)}" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/hyperlink" 
           Target="{$mailto}" TargetMode="External"/>
      </xsl:for-each>
      </Relationships>   
    </xsl:result-document>
   </xsl:if>
  </xsl:template>

</xsl:stylesheet>
