<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
	xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
	xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
	xmlns:w10="urn:schemas-microsoft-com:office:word"
	xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
	xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
	xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
	xmlns:fn="http://www.pageseeder.com/function" xmlns:dec="java:java.net.URLDecoder"  exclude-result-prefixes="#all">
  
  <!--##root##-->
	<xsl:template match="document" mode="content">

		<xsl:choose>
			<xsl:when test="not(ancestor::document)">
<!-- 				<xsl:result-document href="{concat($_outputfolder,'footer1.xml')}"> -->
<!-- 					<xsl:copy-of select="fn:createfooter()" /> -->
<!-- 				</xsl:result-document> -->
<!-- 				<xsl:result-document href="{concat($_outputfolder,'header1.xml')}"> -->
<!-- 					<xsl:copy-of select="fn:createheader()" /> -->
<!-- 				</xsl:result-document> -->
				<w:document>
					<w:body>
						<xsl:apply-templates mode="content" select="section|toc"/>
						<w:sectPr>
							
						</w:sectPr>
					</w:body>
				</w:document>
			</xsl:when>
			<xsl:otherwise>
			  <w:bookmarkStart w:name="{replace(@id,'\W','_')}" w:id="{count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}"/>
    <w:bookmarkEnd  w:id="{count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}" />
				<xsl:apply-templates mode="content" />
				
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
  
  
  <!--##properties##-->
	<xsl:template match="xref-fragment" mode="content">
		<xsl:apply-templates mode="content" />
	</xsl:template>
	
  <xsl:template match="displaytitle" mode="content">

  </xsl:template>
  
  <xsl:template match="documentinfo" mode="content">
  </xsl:template>
  
  <xsl:template match="uri" mode="content">
  </xsl:template>
  
  <xsl:template match="reversexrefs" mode="content">
  </xsl:template>
  
  <xsl:template match="fragmentinfo" mode="content">
  </xsl:template>
  
  <!--##section##-->
	<xsl:template match="section" mode="content">
	 <xsl:variable name="fulltext">
      <xsl:for-each select="./*/*">
        <xsl:value-of select="." />   
      </xsl:for-each>
    </xsl:variable>
	<xsl:variable name="id" select="count(preceding::section)"/>
    <xsl:if test="$configDoc/config/comments/@generate = 'true'">
      <w:p>
       <w:commentRangeStart w:id="{$id}"/>
        <w:r>
         <w:rPr>
           <w:rStyle w:val="CommentReference"/>
         </w:rPr>
           <w:commentReference w:id="{$id}"/>
        </w:r>
       <w:commentRangeEnd w:id="{$id}"/>
      </w:p>
      </xsl:if>
		<xsl:apply-templates mode="content" select="*" />

	</xsl:template>
	
  <!--##body##-->
	<xsl:template match="fragment" mode="content">
<!-- 		<w:p> -->
		  <w:bookmarkStart w:name="{replace(@id,'\W','_')}" w:id="{count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}"/>
    <w:bookmarkEnd  w:id="{count(preceding::fragment) + count(ancestor::fragment) +count(preceding::xref) + count(preceding::document) + count(ancestor::document) + count(preceding::link[@name])}" />
<!-- 		</w:p> -->
		<xsl:apply-templates mode="content" />
	</xsl:template>

    <!--  If could not match any, print this error message -->
	<xsl:template match="*[ancestor::para or ancestor::mitem or ancestor::item ]"
		mode="content" priority="-1">
		<w:r>
			<w:rPr>
				<w:color w:val="991111" />
			</w:rPr>
			<w:t>
				Error unprocessed element:
				<xsl:value-of select="name(.)" />
			</w:t>
		</w:r>
	</xsl:template>

</xsl:stylesheet>