<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
  xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
  xmlns:v="urn:schemas-microsoft-com:vml"
  xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
  xmlns:w10="urn:schemas-microsoft-com:office:word"
  xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
  xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
  xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
  xmlns:fn="http://www.pageseeder.com/function" xmlns:dec="java:java.net.URLDecoder" exclude-result-prefixes="#all">
  
  <!--##list##-->
  <!--##nlist##-->
  <xsl:template match="nlist | list" mode="content">
        <!--
            indenting infomation is in numbering.xml and determined by list level
        -->
    <xsl:apply-templates mode="content" />

  </xsl:template>

  <!--##item##-->
  <xsl:template match="item" mode="content">
      <!-- level of a list item is the number of ancestor list or nlist-->
    <xsl:choose>
      <xsl:when test="text() or link or bold or italic or sup or sub or xref or inline or image">
        <w:p>
          <w:pPr>
<!--             <xsl:choose> -->
<!--               <xsl:when test="inline"> -->
<!--                 <xsl:call-template name="apply-style" /> -->
<!--               </xsl:when> -->
<!--               <xsl:otherwise> -->
                <w:pStyle w:val="BodyText"/>
<!--               </xsl:otherwise> -->
<!--             </xsl:choose> -->
             <xsl:variable name="maxnumId"
          select="max(document(concat($_dotxfolder,$numberingTemplate))/w:numbering/w:num/number(@w:numId))" />
            <w:numPr>
              <w:ilvl w:val="{count(ancestor::list)+count(ancestor::nlist)-1}" />
	            <w:numId w:val="{$maxnumId + count(ancestor::*[name()='list' or name()='nlist'][last()]/
                                                      preceding::*[name()='list' or name()='nlist']
                                                      [not(ancestor::list or ancestor::nlist)])+1}" />
            </w:numPr>
          </w:pPr>
          <xsl:apply-templates select="text() | link | bold | italic | sup | sub | xref | inline | image"  mode="content"/>
        </w:p>
        <xsl:apply-templates select="list|nlist" mode="content"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates  mode="content"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>