<?xml version="1.0"?>
<!--
    This xslt creates numbering.xml
    @cvsid $Id: numbering.xsl,v 1.1 2010/04/13 04:30:09 yfeng Exp $ 
    @author Christine Feng 
-->
<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
	xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
	xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
	xmlns:w10="urn:schemas-microsoft-com:office:word"
	xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
	xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
	xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
	xmlns:fn="http://www.pageseeder.com/function" xmlns:dec="java:java.net.URLDecoder"
	exclude-result-prefixes="#all">


	<xsl:template match="/" mode="numbering">
		<xsl:apply-templates mode="numbering" />
	</xsl:template>

	<xsl:template match="w:numbering" mode="numbering">
		<xsl:variable name="maxAbstractNum"
			select="max(w:abstractNum/number(@w:abstractNumId))" />
		<xsl:variable name="maxNum" select="max(w:num/number(@w:numId))" />
	  <xsl:variable name="nlistconfig" select="$configDoc/config/lists/nlist" as="element()"/>
	  <xsl:variable name="listconfig" select="$configDoc/config/lists/list" as="element()"/>
		<xsl:copy>
			<xsl:copy-of select="@*" />
			<xsl:apply-templates select="*[name() != 'w:num']"
				mode="numbering" />
        <!-- TODO create abstractnum from default and other lists -->
			<xsl:for-each select="$allLists/*">
				<xsl:choose>
				  <xsl:when test="./name() = 'list'">
            <w:abstractNum>
              <xsl:attribute name="w:abstractNumId">
                  <xsl:value-of select="$maxAbstractNum + position()" />
                </xsl:attribute>
              <w:multiLevelType w:val="hybridMultilevel" />
              <xsl:for-each select="$listconfig/level">
                <xsl:call-template name="createLvl">
                  <xsl:with-param name="level" select="@value" />
                  <xsl:with-param name="left-indent" select="left-indent/@value" />
                  <xsl:with-param name="right-indent" select="right-indent/@value" />
                  <xsl:with-param name="hanging" select="hanging/@value" />
                  <xsl:with-param name="format" select="format/@value" />
                  <xsl:with-param name="start" select="start/@value" />
                  <xsl:with-param name="paragraphStyle"
                    select="if (paragraphstyle/@select = 'true') then paragraphstyle/@value else ''" />
                  <xsl:with-param name="justification" select="justification/@value" />
                  <xsl:with-param name="levelText" select="levelText/@value" />
                </xsl:call-template>
              </xsl:for-each>
            </w:abstractNum>
          </xsl:when>
          <xsl:when test="./name() = 'nlist'">
            <w:abstractNum>
              <xsl:attribute name="w:abstractNumId">
                  <xsl:value-of select="$maxAbstractNum + position()" />
                </xsl:attribute>
              <w:multiLevelType w:val="hybridMultilevel" />
              <xsl:for-each select="$nlistconfig/level">
                <xsl:call-template name="createLvl">
                  <xsl:with-param name="level" select="@value" />
                  <xsl:with-param name="left-indent" select="left-indent/@value" />
                  <xsl:with-param name="right-indent" select="right-indent/@value" />
                  <xsl:with-param name="hanging" select="hanging/@value" />
                  <xsl:with-param name="format" select="format/@value" />
                  <xsl:with-param name="start" select="start/@value" />
                  <xsl:with-param name="paragraphStyle"
                    select="if (paragraphstyle/@select = 'true') then paragraphstyle/@value else ''" />
                  <xsl:with-param name="justification" select="justification/@value" />
                  <xsl:with-param name="levelText" select="levelText/@value" />
                </xsl:call-template>
              </xsl:for-each>
            </w:abstractNum>
          </xsl:when>
<!-- 					<xsl:when test="@style =''"> -->
<!-- 						<w:abstractNum> -->
<!-- 							<xsl:attribute name="w:abstractNumId"> -->
<!--                   <xsl:value-of select="$maxAbstractNum + position()" /> -->
<!--                 </xsl:attribute> -->
<!-- 							<w:multiLevelType w:val="hybridMultilevel" /> -->
<!-- 							<xsl:for-each select="level"> -->
<!-- 								<xsl:call-template name="createLvl"> -->
<!-- 									<xsl:with-param name="level" select="@value" /> -->
<!-- 									<xsl:with-param name="left-indent" select="left-indent/@value" /> -->
<!-- 									<xsl:with-param name="right-indent" select="right-indent/@value" /> -->
<!-- 									<xsl:with-param name="hanging" select="hanging/@value" /> -->
<!-- 									<xsl:with-param name="format" select="format/@value" /> -->
<!-- 									<xsl:with-param name="start" select="start/@value" /> -->
<!-- 									<xsl:with-param name="paragraphStyle" -->
<!-- 										select="if (paragraphstyle/@select = 'true') then paragraphstyle/@value else ''" /> -->
<!-- 									<xsl:with-param name="justification" select="justification/@value" /> -->
<!-- 									<xsl:with-param name="levelText" select="levelText/@value" /> -->
<!-- 								</xsl:call-template> -->
<!-- 							</xsl:for-each> -->
<!-- 						</w:abstractNum> -->
<!-- 					</xsl:when> -->
					<xsl:otherwise>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:apply-templates select="w:num" mode="numbering" />
      
	     <xsl:for-each select="$allLists/*">
	       <w:num w:numId="{$maxAbstractNum + position() + 1}">
	         <w:abstractNumId w:val="{$maxAbstractNum + position()}" />
	       </w:num>
	     </xsl:for-each>
		</xsl:copy>

	</xsl:template>

	<xsl:template name="createLvl">
		<xsl:param name="level" />
		<xsl:param name="left-indent" />
		<xsl:param name="right-indent" />
		<xsl:param name="hanging" />
		<xsl:param name="format" />
		<xsl:param name="start" />
		<xsl:param name="paragraphStyle" />
		<xsl:param name="justification" />
		<xsl:param name="levelText" />

		<w:lvl w:ilvl="{$level - 1}">
			<w:start w:val="{$start}" />
			<w:numFmt w:val="{$format}" />
			<w:lvlText w:val="{$levelText}" />
			<w:lvlJc w:val="{$justification}" />
			<xsl:if test="$paragraphStyle != ''">
				<w:pStyle w:val="{$paragraphStyle}" />
			</xsl:if>
			<w:pPr>
				<w:ind w:hanging="{$hanging}">
					<xsl:if test="$left-indent != ''">
						<xsl:attribute name="w:left" select="$left-indent" />
					</xsl:if>
					<xsl:if test="$right-indent != ''">
						<xsl:attribute name="w:right" select="$right-indent" />
					</xsl:if>
				</w:ind>
			</w:pPr>
		</w:lvl>
	</xsl:template>

	<xsl:template match="@*|node()" mode="numbering">
		<xsl:copy>
			<xsl:apply-templates select="@*" mode="styles" />
			<xsl:apply-templates mode="styles" />
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
