<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
  xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
  xmlns:v="urn:schemas-microsoft-com:vml"
  xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
  xmlns:w10="urn:schemas-microsoft-com:office:word"
  xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
  xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
  xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
  xmlns:fn="http://www.pageseeder.com/function" xmlns:dec="java:java.net.URLDecoder"  exclude-result-prefixes="#all">
  
  <!--##toc##-->
  <xsl:template match="toc" mode="content">
    <xsl:choose>
      <xsl:when test="$configDoc/config/toc[@generate = 'true']">
        <xsl:variable name="tocText">
          <xsl:text>TOC </xsl:text>
          <xsl:if test="$configDoc/config/toc/headings[@generate = 'true']">
            <xsl:text>\o "</xsl:text><xsl:value-of select="$configDoc/config/toc/headings/@select"/><xsl:text>" </xsl:text>
	        </xsl:if>
	        <xsl:if test="$configDoc/config/toc/outline[@generate = 'true']">
	          <xsl:text>\u "</xsl:text><xsl:value-of select="$configDoc/config/toc/outline/@select"/><xsl:text>" </xsl:text>
	        </xsl:if>
	        <xsl:if test="$configDoc/config/toc/paragraph[@generate = 'true']">
	         <xsl:text>\t "</xsl:text>
	         <xsl:for-each select="$configDoc/config/toc/paragraph/type">
	           <xsl:choose>
	             <xsl:when test="position() = last()">
	               <xsl:value-of select="concat(./@name,',',./@level)"/>
	             </xsl:when>
	             <xsl:otherwise>
	               <xsl:value-of select="concat(./@name,',',./@level,',')"/>
	             </xsl:otherwise>
	           </xsl:choose>
	         </xsl:for-each>
	         <xsl:text>" </xsl:text>
	        </xsl:if>
        </xsl:variable>
        <w:p>
          <w:pPr>
            <xsl:call-template name="apply-style" />
          </w:pPr>
          <w:r>
	          <w:fldChar w:fldCharType="begin" />
	        </w:r>
	        <w:r>
	          <w:instrText xml:space="preserve"><xsl:value-of select="$tocText" /></w:instrText>
	        </w:r>
	        <w:r>
	          <w:fldChar w:fldCharType="end" />
	        </w:r>
        </w:p>
      </xsl:when>
      <xsl:otherwise>
      
      </xsl:otherwise>
    </xsl:choose>
    
  </xsl:template>


</xsl:stylesheet>