<?xml version="1.0" encoding="UTF-8"?>

  <!--
    This stylesheet transform openXML into PS Format
  
    @author Hugo Inacio 
    @copyright Allette Systems Pty Ltd 
  -->
  
<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
  xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
  xmlns:v="urn:schemas-microsoft-com:vml"
  xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
  xmlns:w10="urn:schemas-microsoft-com:office:word"
  xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
  xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
  xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
  xmlns:fn="http://www.pageseeder.com/function">

<xsl:function name="fn:string-after-last-delimiter">
    <xsl:param name="string"/>
    <xsl:param name="delimiter"/>
    <xsl:analyze-string regex="^(.*)[{$delimiter}]([^{$delimiter}]+)"
      select="$string">
      <xsl:matching-substring>
        <xsl:value-of select="regex-group(2)" />
      </xsl:matching-substring>
    </xsl:analyze-string>
  </xsl:function>

  <xsl:function name="fn:string-before-last-delimiter">
    <xsl:param name="string" />
    <xsl:param name="delimiter" />
    <xsl:analyze-string regex="^(.*)[{$delimiter}][^{$delimiter}]+"
      select="$string">
      <xsl:matching-substring>
        <xsl:value-of select="regex-group(1)" />
      </xsl:matching-substring>
    </xsl:analyze-string>
  </xsl:function>

  <xsl:function name="fn:get-bookmark-value">
    <xsl:param name="string" />
    <xsl:param name="reference" />
    <xsl:analyze-string regex="^(.*)[{$reference}]\s+([\w_\.]+).*"
      select="$string">
      <xsl:matching-substring>
        <xsl:value-of select="regex-group(2)" />
      </xsl:matching-substring>
    </xsl:analyze-string>
  </xsl:function>
  
  <xsl:function name="fn:get-bookmark-value-hyperlink">
    <xsl:param name="string" />
    <xsl:param name="reference" />
    <xsl:analyze-string regex="^(.*)[{$reference}].*&#x022;([\.\w_]+)&#x022;.*"
      select="$string">
      <xsl:matching-substring>
        <xsl:value-of select="regex-group(2)" />
      </xsl:matching-substring>
    </xsl:analyze-string>
  </xsl:function>
  
  <xsl:function name="fn:twentiethpoint-to-pixel">
    <xsl:param name="string" />
    <xsl:value-of select="string(number($string) div 15)"/>
  </xsl:function>

</xsl:stylesheet>