<?xml version="1.0" encoding="utf-8"?>

  <!--
    This stylesheet transform openXML into PS Format
  
    @author Hugo Inacio 
    @copyright Allette Systems Pty Ltd 
  -->

<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
	xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
	xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
	xmlns:w10="urn:schemas-microsoft-com:office:word"
	xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
	xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
	xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
	xmlns:rs="http://schemas.openxmlformats.org/package/2006/relationships"
	xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties"
	xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:dcterms="http://purl.org/dc/terms/"
	xmlns:ps="http://www.pageseeder.com/editing/2.0" xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:fn="http://www.pageseeder.com/function"  exclude-result-prefixes="#all">
  
<!--   <xsl:variable name="mainDoc" select="document($main)"/> -->
  
	<xsl:template match="w:hyperlink" mode="content">
    <!--##link##-->
		<xsl:choose>
			<xsl:when test="@r:id">
				<xsl:variable name="rid" select="@r:id" />
				<link
					href="{document($rels)/rs:Relationships/rs:Relationship[@Id=$rid]/@Target}">
					<xsl:value-of select="w:r/w:t" />
				</link>
			</xsl:when>
			<xsl:when test="@w:anchor">
			 <xsl:variable name="bookmarkRef" select="@w:anchor"/>
        <xref display="manual" type="none"
		      reverselink="true" reversetitle="" reversetype="none">
		      <xsl:attribute name="title">
		             <xsl:value-of select="." />
		        </xsl:attribute>
		      <xsl:attribute name="frag">
		             <xsl:value-of select="replace(@w:anchor,'\W','_')" />
		        </xsl:attribute>
		      <xsl:attribute name="href">
		         <xsl:variable name="document-number">
		          <xsl:value-of
		        select="count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[w:pPr/w:sectPr][w:pPr/w:sectPr/w:type[matches(@w:val,($document-split-sectionbreak))]]) + 
		           count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[matches(w:pPr/w:pStyle/@w:val, ($document-split-styles))][string-join(w:r//text(), '') != '']) +  
		           count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[w:pPr/w:pStyle/@w:val = document($styles)/w:styles/w:style[matches(w:pPr/w:outlineLvl/@w:val,($document-split-outline))]/@w:styleId][string-join(w:r//text(), '') != '']) 
		           + 1" /> 
		         </xsl:variable>
		         <xsl:value-of select="concat($filename,'-',format-number($document-number, $zeropadding),'.psml')" />
		        </xsl:attribute>
		      <xsl:choose>
		        <xsl:when test="@title">
		          <xsl:value-of select="@title" />
		        </xsl:when>
		        <xsl:otherwise>
		          <xsl:value-of select="." />
		        </xsl:otherwise>
		      </xsl:choose>
		    </xref>
      </xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="w:r" mode="content" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

  <!-- Match internal bookmarks for word -->
	<xsl:template
		match="w:r[w:t != ''][preceding-sibling::w:r[1]/w:fldChar[@w:fldCharType='separate']][following-sibling::w:r[1]/w:fldChar[@w:fldCharType='end']]"
		mode="content">
		<xsl:param name="inHeading" select="false()" />
		<xsl:variable name="characterStyleName">
			<xsl:value-of select="w:rPr/w:rStyle/@w:val" />
		</xsl:variable>

		<xsl:variable name="inlineValue">
			<xsl:value-of
				select="$configDoc/config/styles/element[@name=$characterStyleName]/property[@name='name']/@value" />
		</xsl:variable>

		<xsl:variable name="bookmarkRef">
		  <xsl:choose>
		    <xsl:when test="contains(preceding-sibling::w:r[w:instrText][1]/w:instrText[last()],('REF'))">
		      <xsl:value-of
        select="fn:get-bookmark-value((preceding-sibling::w:r[w:instrText][1]/w:instrText)[last()],'REF')" />
		    </xsl:when>
		    <xsl:when test="contains(preceding-sibling::w:r[w:instrText][1]/w:instrText[last()],('PAGEREF'))">
		    <xsl:value-of
        select="fn:get-bookmark-value((preceding-sibling::w:r[w:instrText][1]/w:instrText)[last()],'PAGEREF')" />
		    </xsl:when>
		    <xsl:when test="contains(preceding-sibling::w:r[w:instrText][1]/w:instrText[last()],('HYPERLINK'))">
        <xsl:value-of
        select="fn:get-bookmark-value-hyperlink((preceding-sibling::w:r[w:instrText][1]/w:instrText)[last()],'HYPERLINK')" />
        </xsl:when>
		  </xsl:choose>
		 </xsl:variable>
		<xref display="manual" type="none"
			reverselink="true" reversetitle="" reversetype="none">
			<xsl:attribute name="title">
             <xsl:value-of select="." />
        </xsl:attribute>
			<xsl:attribute name="frag">
         <xsl:choose>
           <xsl:when
				test="$bookmarkRef != ''">
             <xsl:value-of select="replace($bookmarkRef,'\W','_')" />
           </xsl:when>
         </xsl:choose>
        </xsl:attribute>
			<xsl:attribute name="href">
         <xsl:variable name="document-number">
          <xsl:value-of
				select="count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[w:pPr/w:sectPr][w:pPr/w:sectPr/w:type[matches(@w:val,($document-split-sectionbreak))]]) + 
           count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[matches(w:pPr/w:pStyle/@w:val, ($document-split-styles))][string-join(w:r//text(), '') != '']) +  
           count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[w:pPr/w:pStyle/@w:val = document($styles)/w:styles/w:style[matches(w:pPr/w:outlineLvl/@w:val,($document-split-outline))]/@w:styleId][string-join(w:r//text(), '') != '']) 
           + 1" /> 
         </xsl:variable>
         <xsl:value-of select="concat($filename,'-',format-number($document-number, $zeropadding),'.psml')" />
        </xsl:attribute>
			<xsl:choose>
				<xsl:when test="@title">
					<xsl:value-of select="@title" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="." />
				</xsl:otherwise>
			</xsl:choose>
		</xref>
	</xsl:template>
	
	<xsl:template match="w:fldSimple" mode="content">   
    <xsl:variable name="bookmarkRef">
      <xsl:choose>
        <xsl:when test="contains(@w:instr,('REF'))">
          <xsl:value-of
        select="fn:get-bookmark-value(@w:instr,'REF')" />
        </xsl:when>
        <xsl:when test="contains(@w:instr,('PAGEREF'))">
        <xsl:value-of
        select="fn:get-bookmark-value(@w:instr,'PAGEREF')" />
        </xsl:when>
      </xsl:choose>
     </xsl:variable>
     
     <xref display="manual" type="none"
      reverselink="true" reversetitle="" reversetype="none">
      <xsl:attribute name="title">
             <xsl:value-of select="." />
        </xsl:attribute>
      <xsl:attribute name="frag">
         <xsl:choose>
           <xsl:when
        test="$bookmarkRef != ''">
             <xsl:value-of select="replace($bookmarkRef,'\W','_')" />
           </xsl:when>
         </xsl:choose>
        </xsl:attribute>
      <xsl:attribute name="href">
         <xsl:variable name="document-number">
          <xsl:value-of
        select="count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[w:pPr/w:sectPr][w:pPr/w:sectPr/w:type[matches(@w:val,($document-split-sectionbreak))]]) + 
           count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[matches(w:pPr/w:pStyle/@w:val, ($document-split-styles))][string-join(w:r//text(), '') != '']) +  
           count(document($main)//w:bookmarkStart[@w:name=$bookmarkRef]/preceding::w:p[w:pPr/w:pStyle/@w:val = document($styles)/w:styles/w:style[matches(w:pPr/w:outlineLvl/@w:val,($document-split-outline))]/@w:styleId][string-join(w:r//text(), '') != '']) 
           + 1" /> 
         </xsl:variable>
         <xsl:value-of select="concat($filename,'-',format-number($document-number, $zeropadding),'.psml')" />
        </xsl:attribute>
      <xsl:choose>
        <xsl:when test="@title">
          <xsl:value-of select="@title" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="." />
        </xsl:otherwise>
      </xsl:choose>
    </xref>
  </xsl:template>

</xsl:stylesheet>