<?xml version="1.0" encoding="utf-8"?>

  <!--
    This stylesheet transform openXML into PS Format
  
    @author Hugo Inacio 
    @copyright Allette Systems Pty Ltd 
  -->

<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
  xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
  xmlns:v="urn:schemas-microsoft-com:vml"
  xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
  xmlns:w10="urn:schemas-microsoft-com:office:word"
  xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
  xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
  xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
  xmlns:rs="http://schemas.openxmlformats.org/package/2006/relationships"
  xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties"
  xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:dcterms="http://purl.org/dc/terms/"
  xmlns:ps="http://www.pageseeder.com/editing/2.0" xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:fn="http://www.pageseeder.com/function"  exclude-result-prefixes="#all">
  
 
<!-- =============================================================
         Match w:p with w:numPr
         create list item
     ============================================================= -->
  <xsl:template match="w:p" mode="insideList">
    <xsl:variable name="level" select="w:pPr/w:numPr/w:ilvl/@w:val" />

    <xsl:variable name="nested-list"
      select="following-sibling::w:p[1][w:pPr/w:numPr/w:ilvl/@w:val &gt; $level]" />
      <!--##item##-->
    <item>
      <xsl:apply-templates mode="content" select="*"/>
      <xsl:for-each select="$nested-list">
        <xsl:variable name="nlistID" select="w:pPr/w:numPr/w:numId/@w:val" />
        <xsl:call-template name="list">
          <xsl:with-param name="abstractId"
            select="document($numbering)/w:numbering/w:num[@w:numId=$nlistID]/w:abstractNumId/@w:val" />
          <xsl:with-param name="level" select="w:pPr/w:numPr/w:ilvl/@w:val" />
        </xsl:call-template>
      </xsl:for-each>
    </item>

    <xsl:variable name="listID" select="w:pPr/w:numPr/w:numId/@w:val" />
    <xsl:choose>
      <xsl:when test="$nested-list">
          <!-- skip to next item at this level just after nested list -->
        <xsl:apply-templates
          select="following-sibling::w:p
              [w:pPr/w:numPr/w:ilvl/@w:val=$level][w:pPr/w:numPr/w:numId/@w:val=$listID][1]
              [preceding-sibling::w:p[1]/w:pPr/w:numPr/w:ilvl/@w:val &gt; $level]"
          mode="insideList">
        </xsl:apply-templates>
      </xsl:when>
      <xsl:otherwise>
          <!-- get next item if it is at the same level -->
        <xsl:apply-templates
          select="following-sibling::w:p[1]
              [w:pPr/w:numPr/w:ilvl/@w:val=$level][w:pPr/w:numPr/w:numId/@w:val=$listID]"
          mode="insideList">
        </xsl:apply-templates>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
    
<!-- =============================================================
         create list or nlist, based on the list type defined
         in numbering.xml
     ============================================================= -->
  <!--##list##-->
  <!--##nlist##-->
  <xsl:template name="list">
    <xsl:param name="abstractId" />
    <xsl:param name="level" />
    <xsl:choose>
      <xsl:when
        test="document($numbering)/w:numbering/w:abstractNum[@w:abstractNumId=$abstractId]/w:lvl[@w:ilvl=$level]/w:numFmt/@w:val='bullet'">
        <list>
          <xsl:apply-templates select="." mode="insideList" />
        </list>
      </xsl:when>
      <xsl:otherwise>
        <nlist>
          <xsl:apply-templates select="." mode="insideList" />
        </nlist>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>