<?xml version="1.0" encoding="utf-8"?>

  <!--
    This stylesheet transform openXML into PS Format
  
    @author Hugo Inacio 
    @copyright Allette Systems Pty Ltd 
  -->

<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
	xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
	xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
	xmlns:w10="urn:schemas-microsoft-com:office:word"
	xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
	xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
	xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
	xmlns:rs="http://schemas.openxmlformats.org/package/2006/relationships"
	xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties"
	xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:dcterms="http://purl.org/dc/terms/"
	xmlns:ps="http://www.pageseeder.com/editing/2.0" xmlns:xs="http://www.w3.org/2001/XMLSchema"
	 exclude-result-prefixes="#all">

	<xsl:variable name="section-split-styles">
	 <xsl:choose>
     <xsl:when test="$configDoc/config/split/section/type[@name = 'style']/@select = ''">
       <xsl:value-of select="'no Submitted Value'" />
     </xsl:when>
     <xsl:otherwise>
       <xsl:value-of select="$configDoc/config/split/section/type[@name = 'style']/@select" />
     </xsl:otherwise>
   </xsl:choose>
	</xsl:variable>

	<xsl:variable name="section-split-outline">
	 <xsl:choose>
     <xsl:when test="$configDoc/config/split/section/type[@name = 'outlineLevel']/@select = ''">
       <xsl:value-of select="'no Submitted Value'" />
     </xsl:when>
     <xsl:otherwise>
       <xsl:value-of select="$configDoc/config/split/document/type[@name = 'outlineLevel']/@select" />
     </xsl:otherwise>
   </xsl:choose>
	</xsl:variable>

	<xsl:variable name="section-split-sectionbreak">
	 <xsl:choose>
     <xsl:when test="$configDoc/config/split/section/type[@name = 'sectionBreak']/@select = ''">
       <xsl:value-of select="'no Submitted Value'" />
     </xsl:when>
     <xsl:otherwise>
       <xsl:value-of select="$configDoc/config/split/document/type[@name = 'sectionBreak']/@select" />
     </xsl:otherwise>
   </xsl:choose>
	</xsl:variable>

  <xsl:variable name="section-split-reference">
   <xsl:choose>
     <xsl:when test="$configDoc/config/split/section/type[@name = 'references']/@select = ''">
       <xsl:value-of select="'no Submitted Value'" />
     </xsl:when>
     <xsl:otherwise>
       <xsl:value-of select="$configDoc/config/split/document/type[@name = 'references']/@select" />
     </xsl:otherwise>
   </xsl:choose>
  </xsl:variable>
  
	<xsl:template match="body" mode="section-split">
        <xsl:for-each-group select="*"
			group-ending-with="w:p[w:pPr/w:sectPr][w:pPr/w:sectPr/w:type[matches(@w:val,($section-split-sectionbreak))]]">
			<xsl:for-each-group select="current-group()"
				group-starting-with="w:p[matches(w:pPr/w:pStyle/@w:val, ($section-split-styles))]|
        w:p[w:pPr/w:pStyle/@w:val = document($styles)/w:styles/w:style[matches(w:pPr/w:outlineLvl/@w:val,($section-split-outline))]/@w:styleId][string-join(w:r//text(), '') != '']"> 
        <xsl:for-each-group select="current-group()"
        group-starting-with="w:p[w:bookmarkStart]">
					<xsl:choose>
						<xsl:when test="current-group()//w:bookmarkStart">
							<section id="{replace((current-group()//w:bookmarkStart)[1]/@w:name,'\W','_')}">
								<fragment id="{replace((current-group()//w:bookmarkStart)[1]/@w:name,'\W','_')}">
									<xsl:apply-templates select="current-group()"
										mode="content" />
								</fragment>
							</section>
						</xsl:when>
						<xsl:otherwise>
<!-- 				        <xsl:variable name="listID" select="w:p[1]/w:pPr/w:numPr/w:numId/@w:val" /> -->
<!-- 				        <xsl:choose> -->
<!-- 				          <xsl:when -->
<!-- 				            test="w:p[1]/w:pPr/w:numPr/w:numId/@w:val and preceding-sibling::w:p[1][./w:pPr/w:numPr/w:numId/@w:val = $listID]" /> -->
<!-- 				          <xsl:otherwise> -->
				           <section id="{count(preceding::w:p)+1}">
                    <fragment id="{count(preceding::w:p)+1}">
                      <xsl:apply-templates select="current-group()"
                        mode="content" />
                    </fragment>
                  </section>
<!-- 				          </xsl:otherwise> -->
<!-- 				        </xsl:choose> -->
						</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each-group>
			</xsl:for-each-group>
		</xsl:for-each-group>
	</xsl:template>

</xsl:stylesheet>