<?xml version="1.0" encoding="UTF-8"?>
<?xar Schematron?>
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron"
            queryBinding="xslt2" >
        <sch:title>Validation for importing docx as PSXML</sch:title>
        <sch:ns prefix="w" uri="http://schemas.openxmlformats.org/wordprocessingml/2006/main"/>
        <sch:ns prefix="r" uri="http://schemas.openxmlformats.org/officeDocument/2006/relationships"/>
        <sch:ns prefix="ve" uri="http://schemas.openxmlformats.org/markup-compatibility/2006" />
        <sch:ns prefix="o" uri="urn:schemas-microsoft-com:office:office"/>
        <sch:ns prefix="r" uri="http://schemas.openxmlformats.org/officeDocument/2006/relationships"/> 
        <sch:ns prefix="m" uri="http://schemas.openxmlformats.org/officeDocument/2006/math" /> 
        <sch:ns prefix="v" uri="urn:schemas-microsoft-com:vml" />
        <sch:ns prefix="wp" uri="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing" />
        <sch:ns prefix="w10" uri="urn:schemas-microsoft-com:office:word" />
        <sch:ns prefix="w" uri="http://schemas.openxmlformats.org/wordprocessingml/2006/main"/>
        <sch:ns prefix="wne" uri="http://schemas.microsoft.com/office/word/2006/wordml"/>
        
    <!-- 
        ==========================================================================
        This schema validates docx for importing as PSXML.
        
        @author Christine Feng
        @author William Liem
        @author Rick Jellife
        @author Philip Rutherford
        @version 23 March 2011
    
        Copyright (C) 2011 Weborganic Systems Pty. Ltd.
        ==========================================================================
     -->
    
    <sch:pattern id="Elements">
        
        
        
                
        <!-- 
              Table and contents of tables rules
        -->
        <sch:rule context="config/defaultparagraphstyle"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/defaultcharacterstyle"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/block"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/inline"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/tables"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/heading"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/toc"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/xref"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/lists"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/*">
            <sch:report test="true()">[FATAL]:element config cannot contain element: <sch:value-of select="."/> . 
            It can only contain the elements: defaultparagraphstyle,defaultcharacterstyle,block, inline,tables, heading, toc, xref and lists</sch:report>
        </sch:rule>
        
        <sch:rule context="block/label"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="block/*">
            <sch:report test="true()">[FATAL]:element block cannot contain element: <sch:value-of select="."/> . It can only contain the element: label</sch:report>
        </sch:rule>
        
        <sch:rule context="block/@default"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="block/@ignore"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="block/*@">
            <sch:report test="true()">[FATAL]:element block cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: default and ignore</sch:report>
        </sch:rule>
        
        <sch:rule context="block/label/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="block/label/@style"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="block/label/*@">
            <sch:report test="true()">[FATAL]:element label cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and style</sch:report>
        </sch:rule>
        
        <sch:rule context="inline/label"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="inline/*">
            <sch:report test="true()">[FATAL]:element inline cannot contain element: <sch:value-of select="."/> . It can only contain the element: label</sch:report>
        </sch:rule>
        
        <sch:rule context="inline/@default"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="inline/@ignore"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="inline/*@">
            <sch:report test="true()">[FATAL]:element inline cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: default and ignore</sch:report>
        </sch:rule>
        
        <sch:rule context="inline/label/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="inline/label/@style"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="inline/label/*@">
            <sch:report test="true()">[FATAL]:element label cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and style</sch:report>
        </sch:rule>
        
        <sch:rule context="tables/style"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="tables/*">
            <sch:report test="true()">[FATAL]:element tables cannot contain element: <sch:value-of select="."/> . It can only contain the element: style</sch:report>
        </sch:rule>
        
        <sch:rule context="tables/@default"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="tables/*@">
            <sch:report test="true()">[FATAL]:element tables cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: default</sch:report>
        </sch:rule>
        
        <sch:rule context="tables/style/@role"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="tables/style/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="tables/style/*@">
            <sch:report test="true()">[FATAL]:element style cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and role</sch:report>
        </sch:rule>
        
        <sch:rule context="heading/style"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="heading/*">
            <sch:report test="true()">[FATAL]:element heading cannot contain element: <sch:value-of select="."/> . It can only contain the element: style</sch:report>
        </sch:rule>
        
        <sch:rule context="heading/style/@level"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="heading/style/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="heading/style/*@">
            <sch:report test="true()">[FATAL]:element style cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and level</sch:report>
        </sch:rule>
        
        <sch:rule context="heading/style">
            <sch:report test="contains(@level,'[^1-6]'">[FATAL]:attribute level can only contain : '1-6'</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/headings"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/outline"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/paragraph"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/*">
            <sch:report test="true()">[FATAL]:element toc cannot contain element: <sch:value-of select="."/> . It can only contain the elements: headings,outline and paragraph</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/@generate"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/@style"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/*@">
            <sch:report test="true()">[FATAL]:element toc cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: generate and style</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/headings/@generate"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/headings/@select"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/headings/*@">
            <sch:report test="true()">[FATAL]:element headings cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: generate and select</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/headings">
            <sch:report test="contains(@generate,'[^true] and [^false]'">[FATAL]:attribute generate can only contain : 'true' or 'false'</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/headings">
            <sch:report test="contains(@select,'[^1-9] and [^\|]'">[FATAL]:attribute select can only contain : '1-9' or '|'</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/outline/@generate"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/outline/@select"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/outline/*@">
            <sch:report test="true()">[FATAL]:element outline cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: generate and select</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/outline">
            <sch:report test="contains(@generate,'[^true] and [^false]'">[FATAL]:attribute generate can only contain : 'true' or 'false'</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/outline">
            <sch:report test="contains(@select,'[^1-9] and [^\|]'">[FATAL]:attribute select can only contain : '1-9' or '|'</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/paragraph/@generate"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/paragraph/*@">
            <sch:report test="true()">[FATAL]:element paragraph cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: generate</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/paragraph/type"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/paragraph/*">
            <sch:report test="true()">[FATAL]:element paragraph cannot contain element: <sch:value-of select="."/> . It can only contain the element: type</sch:report>
        </sch:rule>
        
        <sch:rule context="toc/paragraph/type/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/paragraph/type/@level"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="toc/paragraph/type/*@">
            <sch:report test="true()">[FATAL]:element type cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and level</sch:report>
        </sch:rule>
         
        <sch:rule context="lists/list"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/*">
            <sch:report test="true()">[FATAL]:element lists cannot contain element: <sch:value-of select="."/> . It can only contain the elements: list and nlist</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/*">
            <sch:report test="true()">[FATAL]:element list cannot contain element: <sch:value-of select="."/> . It can only contain the elements: level</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/*">
            <sch:report test="true()">[FATAL]:element nlist cannot contain element: <sch:value-of select="."/> . It can only contain the elements: level</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/@style"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/*@">
            <sch:report test="true()">[FATAL]:element list cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and style</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/@style"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/*@">
            <sch:report test="true()">[FATAL]:element nlist cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and style</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/*@">
            <sch:report test="true()">[FATAL]:element level cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/left-indent"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/right-indent"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/hanging"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/format"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/start"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/paragraphstyle"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/justification"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/levelText"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/*">
            <sch:report test="true()">[FATAL]:element lists cannot contain element: <sch:value-of select="."/> . It can only contain the elements: list and nlist</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/left-indent/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/left-indent/*@">
            <sch:report test="true()">[FATAL]:element left-indent cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/right-indent/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/right-indent/*@">
            <sch:report test="true()">[FATAL]:element right-indent cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/hanging/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/hanging/*@">
            <sch:report test="true()">[FATAL]:element hanging cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/format/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/format/*@">
            <sch:report test="true()">[FATAL]:element format cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/start/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/start/*@">
            <sch:report test="true()">[FATAL]:element start cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/paragraphstyle/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/paragraphstyle/@select"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/paragraphstyle/*@">
            <sch:report test="true()">[FATAL]:element paragraphstyle cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: value and select</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/justification/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/justification/*@">
            <sch:report test="true()">[FATAL]:element justification cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/list/level/levelText/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/list/level/levelText/*@">
            <sch:report test="true()">[FATAL]:element levelText cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/*@">
            <sch:report test="true()">[FATAL]:element level cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/left-indent"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/right-indent"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/hanging"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/format"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/start"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/paragraphstyle"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/justification"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/levelText"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/*">
            <sch:report test="true()">[FATAL]:element lists cannot contain element: <sch:value-of select="."/> . It can only contain the elements: list and nlist</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/left-indent/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/left-indent/*@">
            <sch:report test="true()">[FATAL]:element left-indent cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/right-indent/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/right-indent/*@">
            <sch:report test="true()">[FATAL]:element right-indent cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/hanging/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/hanging/*@">
            <sch:report test="true()">[FATAL]:element hanging cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/format/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/format/*@">
            <sch:report test="true()">[FATAL]:element format cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/start/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/start/*@">
            <sch:report test="true()">[FATAL]:element start cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/paragraphstyle/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/paragraphstyle/@select"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/paragraphstyle/*@">
            <sch:report test="true()">[FATAL]:element paragraphstyle cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: value and select</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/justification/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/justification/*@">
            <sch:report test="true()">[FATAL]:element justification cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
        <sch:rule context="lists/nlist/level/levelText/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="lists/nlist/level/levelText/*@">
            <sch:report test="true()">[FATAL]:element levelText cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: value</sch:report>
        </sch:rule>
        
    </sch:pattern>
</sch:schema>
