<?xml version="1.0" encoding="UTF-8"?>
<?xar Schematron?>
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron"
            queryBinding="xslt2" >
        <sch:title>Validation for importing docx as PSXML</sch:title>
        <sch:ns prefix="w" uri="http://schemas.openxmlformats.org/wordprocessingml/2006/main"/>
        <sch:ns prefix="r" uri="http://schemas.openxmlformats.org/officeDocument/2006/relationships"/>
        <sch:ns prefix="ve" uri="http://schemas.openxmlformats.org/markup-compatibility/2006" />
        <sch:ns prefix="o" uri="urn:schemas-microsoft-com:office:office"/>
        <sch:ns prefix="r" uri="http://schemas.openxmlformats.org/officeDocument/2006/relationships"/> 
        <sch:ns prefix="m" uri="http://schemas.openxmlformats.org/officeDocument/2006/math" /> 
        <sch:ns prefix="v" uri="urn:schemas-microsoft-com:vml" />
        <sch:ns prefix="wp" uri="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing" />
        <sch:ns prefix="w10" uri="urn:schemas-microsoft-com:office:word" />
        <sch:ns prefix="w" uri="http://schemas.openxmlformats.org/wordprocessingml/2006/main"/>
        <sch:ns prefix="wne" uri="http://schemas.microsoft.com/office/word/2006/wordml"/>
        
    <!-- 
        ==========================================================================
        This schema validates docx for importing as PSXML.
        
        @author Christine Feng
        @author William Liem
        @author Rick Jellife
        @author Philip Rutherford
        @version 23 March 2011
    
        Copyright (C) 2011 Weborganic Systems Pty. Ltd.
        ==========================================================================
     -->
    
    <sch:pattern id="Elements">
        
        
        
                
        <!-- 
              Table and contents of tables rules
        -->
        <sch:rule context="config/styles"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/numbering"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/split"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/toc"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="config/*">
            <sch:report test="true()">[FATAL]:element config cannot contain element: <sch:value-of select="."/> . It can only contain the elements: styles,numbering,split and toc</sch:report>
        </sch:rule>
        
        <sch:rule context="split/document"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/section"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/*">
            <sch:report test="true()">[FATAL]:element split cannot contain element: <sch:value-of select="."/> . It can only contain the elements: document and section</sch:report>
        </sch:rule>
        
        
        
        <sch:rule context="split/document/type"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/document/*">
            <sch:report test="true()">[FATAL]:element document cannot contain element: <sch:value-of select="."/> . It can only contain the elements: type</sch:report>
        </sch:rule>
        
        <sch:rule context="split/section/type"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/section/*">
            <sch:report test="true()">[FATAL]:element section cannot contain element: <sch:value-of select="."/> . It can only contain the elements: type</sch:report>
        </sch:rule>
        
        <sch:rule context="split/document/type/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/document/type/@select"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/document/type/*@">
            <sch:report test="true()">[FATAL]:element type cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and select</sch:report>
        </sch:rule>
        
        <sch:rule context="split/section/type/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/section/type/@select"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="split/section/type/*@">
            <sch:report test="true()">[FATAL]:element type cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and select</sch:report>
        </sch:rule>
        
        <sch:rule context="split/document/type">
            <sch:report test="contains(@name,'[^sectionType] and [^outlineLevel] and [^sectionBreak]'">[FATAL]:attribute name can only contain : 'sectionType' or 'outlineLevel' or 'sectionBreak'</sch:report>
        </sch:rule>
        
        <sch:rule context="split/section/type">
            <sch:report test="contains(@name,'[^sectionType] and [^outlineLevel] and [^sectionBreak]'">[FATAL]:attribute name can only contain : 'sectionType' or 'outlineLevel' or 'sectionBreak'</sch:report>
        </sch:rule>
        
        <sch:rule context="split/document/type[@name = 'sectionBreak']">
            <sch:report test="contains(@select,'[^continuous] and [^evenPage] and [^oddPage] and [^|]'">[FATAL]:attribute select can only contain : 'continuous' or 'evenPage' or 'oddPage' or '|'</sch:report>
        </sch:rule>
        
        <sch:rule context="split/document/type[@name = 'outlineLevel']">
            <sch:report test="contains(@select,'[^1-6] and [^\|]'">[FATAL]:attribute select can only contain : '1-6' or '|'</sch:report>
        </sch:rule>
        
        <sch:rule context="split/section/type[@name = 'sectionBreak']">
            <sch:report test="contains(@select,'[^continuous] and [^evenPage] and [^oddPage] and [^|]'">[FATAL]:attribute select can only contain : 'continuous' or 'evenPage' or 'oddPage' or '|'</sch:report>
        </sch:rule>
        
        <sch:rule context="split/section/type[@name = 'outlineLevel']">
            <sch:report test="contains(@select,'[^1-6] and [^\|]'">[FATAL]:attribute select can only contain : '1-6' or '|'</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/default"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/smart-tag"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/element"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/*">
            <sch:report test="true()">[FATAL]:element styles cannot contain element: <sch:value-of select="."/> . It can only contain the elements: default,smart-tag and element</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/default/property"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/default/*">
            <sch:report test="true()">[FATAL]:element default cannot contain element: <sch:value-of select="."/> . It can only contain the element: property</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/default/property/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/default/property/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/default/property/@*">
            <sch:report test="true()">[FATAL]:element property cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and value</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/default/property">
            <sch:report test="contains(@name,'[^paragraphStyles] and [^prefix] and [^characterStyles]'">[FATAL]:attribute name can only contain : 'paragraphStyles' or 'prefix' or 'characterStyles'</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/default/property[@name = 'paragraphStyles']">
            <sch:report test="contains(@value,'[^block] and [^para] '">[FATAL]:attribute value can only contain : 'block' or 'para'</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/default/property[@name = 'characterStyles']">
            <sch:report test="contains(@value,'[^inlineLabel] and [^none] '">[FATAL]:attribute value can only contain : 'inlineLabel' or 'none'</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/default/property[@name = 'prefix']">
            <sch:report test="contains(@value,'[^false] and [^true] '">[FATAL]:attribute value can only contain : 'false' or 'true'</sch:report>
        </sch:rule>
        
        <sch:rule context="numbering/value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="numbering/*">
            <sch:report test="true()">[FATAL]:element numbering cannot contain element: <sch:value-of select="."/> . It can only contain the element: value</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/smart-tag/@keep"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/default/property/@*">
            <sch:report test="true()">[FATAL]:element smart-tag cannot contain attribute: <sch:value-of select="."/> . It can only contain the attribute: keep</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/smart-tag">
            <sch:report test="contains(@keep,'[^true] and [^false]'">[FATAL]:attribute name can only contain : 'true' or 'false'</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/element/property"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/element/*">
            <sch:report test="true()">[FATAL]:element element cannot contain element: <sch:value-of select="."/> . It can only contain the element: property</sch:report>
        </sch:rule>
        
        <sch:rule context="styles/element/property/@name"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/element/property/@value"><sch:assert test="true()"/></sch:rule>
        <sch:rule context="styles/element/property/@*">
            <sch:report test="true()">[FATAL]:element property cannot contain attribute: <sch:value-of select="."/> . It can only contain the attributes: name and value</sch:report>
        </sch:rule>
        
        <sch:rule context="w:tbl[descendant::w:tbl]">
            <sch:assert test="false()">[FATAL]:A table inside a table is not supported</sch:assert>
        </sch:rule>
        
        <sch:rule context="w:tbl" >
          <sch:report test="w:tr">A table must contain at least one row: near text '<sch:value-of select="."/>'</sch:report>
          <sch:report test="not(w:tr and w:tblPr and w:tblGrid)">[WARNING]:The Row containing '<sch:value-of select="."/>' will not be imported</sch:report>
        </sch:rule>
        
        <sch:rule context="w:tr" >
          <sch:report test="w:tc">A row must contain at least one cell: near text '<sch:value-of select="."/>'</sch:report>
          <sch:report test="not(w:tc and w:trPr)">[WARNING]:The Cell containing '<sch:value-of select="."/>' will not be imported</sch:report>
        </sch:rule>
        
        <sch:rule context="w:tr/w:trPr"><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:tr/w:tc"><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:tbl/*">
            <sch:report test="true()">[FATAL]:A table row cannot contain element <sch:value-of select="."/> . A table row can only contain the elements: w:trPr and w:tc</sch:report>
        </sch:rule>
        
        <!-- 
              Warning: Tables found
              If tables are found, an entry should be added to the error report regarding widths - the error is non-fatal.
        -->
        <sch:rule context="w:tbl">
            <sch:report test="true()">Table cell widths will be ignored:</sch:report>
        </sch:rule>
        
        <!-- 
              Character Formating
        -->
        <sch:rule context="w:rPr">
            <sch:report test="not(w:b and w:i and w:u)">[WARNING]:Formatting '<sch:value-of select="."/>' will not be implemented</sch:report>
        </sch:rule>
       
       <sch:rule context="w:rPr/w:vertAlign[@w:val='subscript']" ><sch:assert test="true()" /></sch:rule>
       <sch:rule context="w:rPr/w:vertAlign[@w:val='superscript']" ><sch:assert test="true()" /></sch:rule>
       <sch:rule context="w:rPr/w:vertAlign[@w:val]">
            <sch:report test="true()">[WARNING]:Formatting '<sch:value-of select="."/>' will not be implemented</sch:report>
        </sch:rule>
        
        
        <!--
             Invalid headings - these errors are non-fatal.
             Currently the following validation is performed:
              - cannot have empty content (stripped out)
              - cannot contain an image (image is stripped out)
              - cannot be located in a table (turned to a paragraph) 
        -->
        <sch:rule context="w:p[matches(w:pPr/w:pStyle/@w:val, 'Heading(1|2|3|4|5|6)')]" >
          <sch:report test="string-join(w:r//text(), '') != ''">Empty headings will be ignored: Empty <sch:value-of select="w:pPr/w:pStyle/@w:val"/> found</sch:report>
          <sch:report test="empty(.//w:drawing | .//w:pict)">Images in headings will be stripped out:<sch:value-of select="w:r/w:t"/></sch:report>
          <sch:report test="empty(ancestor::w:tbl)">Headings in table will be imported as paragraphs:<sch:value-of select="w:r/w:t"/></sch:report>
        </sch:rule>
        
        <!--
             Style mismatch 
             Where a style is not supported, an entry should be added to the error report containing the text and processing should continue - the error is non-fatal.
        -->
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='Heading1']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='Heading2']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='Heading3']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='Heading4']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='Heading5']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='Heading6']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='Caption']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val='ListParagraph']" ><sch:assert test="true()" /></sch:rule>
        <sch:rule context="w:p/w:pPr/w:pStyle[@w:val]">
            <sch:report test="true()">Unsupported style <sch:value-of select="@w:val"/> will be imported as paragraph:<sch:value-of select="../../w:r/w:t"/></sch:report>
        </sch:rule>

    </sch:pattern>
</sch:schema>
