<?xml version="1.0"?>
<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
  xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
  xmlns:v="urn:schemas-microsoft-com:vml"
  xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
  xmlns:w10="urn:schemas-microsoft-com:office:word"
  xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
  xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
  xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
  xmlns:rs="http://schemas.openxmlformats.org/package/2006/relationships"
  xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties"
  xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:dcterms="http://purl.org/dc/terms/"
  xmlns:ps="http://www.pageseeder.com/editing/2.0" xmlns:xs="http://www.w3.org/2001/XMLSchema"
   exclude-result-prefixes="#all">

  <xsl:output encoding="UTF-8" method="xml" indent="no" />

    
  <xsl:template match="/">
    <xsl:apply-templates select="element()|text()|comment()|processing-instruction()"/>
  </xsl:template>

  <xsl:template match="attribute()|comment()|processing-instruction()">
    <xsl:copy>
      <xsl:apply-templates select="comment()|processing-instruction()"/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="element()">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="w:proofErr"/>
  
  
  
  <!--comment ID: 302792, fixed mixed content-->
  <xsl:template match="w:p">
  <w:p>
        <xsl:for-each-group select="*"
          group-adjacent="not(current()/name() = 'w:r' and current()[w:t])">
          <xsl:choose>
            <xsl:when test="current-grouping-key()">
              <xsl:for-each select="current-group()">
                <xsl:if test="not(w:proofErr)">
                <xsl:copy-of select="." />
                </xsl:if>
              </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
              <xsl:for-each-group select="current-group()"
                group-adjacent="if (current()/name() = 'w:r' and current()[not(w:rPr)]) then 1 else 2">
                <xsl:choose>
                  <xsl:when test="current-grouping-key() = 1">
<!--                      <one> -->
<!--                      <xsl:apply-templates select="current-group()" mode="xml"/> -->
<!--                      </one> -->
                    <xsl:variable name="contents" as="element()">
                      <contents>
                        <xsl:copy-of select="current-group()/*" />
                      </contents>
                    </xsl:variable>
                    <xsl:for-each-group select="$contents/*"
                      group-starting-with="w:fldChar[@w:fldCharType='begin']">
<!--                           <two> -->
<!--                           <xsl:apply-templates select="current-group()" mode="xml"/> -->
<!--                           </two> -->
                      <xsl:for-each-group select="current-group()"
                        group-starting-with="w:fldChar[@w:fldCharType='separate']">
                        <xsl:for-each-group select="current-group()"
                          group-starting-with="w:fldChar[@w:fldCharType='end']">
                          <xsl:for-each-group select="current-group()"
                            group-ending-with="w:fldChar[@w:fldCharType='end']">
<!--                           <three> -->
<!--                           <xsl:apply-templates select="current-group()" mode="xml"/> -->
<!--                           </three> -->
                            <w:r>
                              <xsl:for-each-group select="current-group()"
                                group-adjacent="if (self::w:t) then 1 else 2">
                                <xsl:choose>
                                  <xsl:when test="current-grouping-key() = 2">
                                    <xsl:copy-of select="current-group()" />
                                  </xsl:when>
                                  <xsl:otherwise>
                                    <w:t xml:space="preserve"><xsl:value-of select="string-join(current-group(),'')" /></w:t>
                                  </xsl:otherwise>
                                </xsl:choose>
                              </xsl:for-each-group>
                            </w:r>
                          </xsl:for-each-group>
                        </xsl:for-each-group>
                      </xsl:for-each-group>
                    </xsl:for-each-group>
                  </xsl:when>
                  <xsl:otherwise>
<!--                      <xsl:apply-templates select="current-group()" mode="xml"/> -->
                    <xsl:for-each-group select="current-group()"
                      group-starting-with="*[name() = 'w:r'][deep-equal(following-sibling::*[1]/w:rPr,current()/w:rPr)][not(deep-equal(preceding-sibling::*[1]/w:rPr,current()/w:rPr))]">
<!--                        <one1> -->
<!--                       <xsl:apply-templates select="current-group()" mode="xml"/> -->
<!--                       </one1> -->
                      <xsl:variable name="contents" as="element()">
                        <contents>
                          <xsl:copy-of select="current-group()/*[name() != 'w:rPr']" />
                        </contents>
                      </xsl:variable>
                      <xsl:for-each-group select="$contents/*"
                        group-starting-with="w:r/w:fldChar[@w:fldCharType='begin']">
<!--                           <two1> -->
<!--                           <xsl:apply-templates select="current-group()" mode="xml"/> -->
<!--                           </two1> -->
                        <xsl:for-each-group select="current-group()"
                          group-ending-with="w:fldChar[@w:fldCharType='separate']">
                          <xsl:for-each-group select="current-group()"
                            group-starting-with="w:fldChar[@w:fldCharType='end']">
                            <xsl:for-each-group select="current-group()"
                              group-ending-with="w:fldChar[@w:fldCharType='end']">
<!--                           <three1> -->
<!--                           <xsl:apply-templates select="current-group()" mode="xml"/> -->
<!--                           </three1> -->
                              <w:r>
                                <xsl:copy-of select="(current-group()/w:rPr)[1]" />
                          
<!--                          <xsl:apply-templates select="$contents" mode="xml"/> -->
                                <xsl:for-each-group select="current-group()"
                                  group-adjacent="if (self::w:t) then 1 else 2">
                                  <xsl:choose>
                                    <xsl:when test="current-grouping-key() = 2">
                                      <xsl:copy-of select="current-group()[name() != 'w:rPr']" />
                                    </xsl:when>
                                    <xsl:otherwise>
                                      <w:t xml:space="preserve"><xsl:value-of select="string-join(current-group(),'')" /></w:t>
                                    </xsl:otherwise>
                                  </xsl:choose>
                                </xsl:for-each-group>
                              </w:r>
                            </xsl:for-each-group>
                          </xsl:for-each-group>
                        </xsl:for-each-group>
                      </xsl:for-each-group>
                    </xsl:for-each-group>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each-group>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:for-each-group>
        </w:p>
  </xsl:template>

</xsl:stylesheet>
