<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                              xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties"
                              xmlns:dc="http://purl.org/dc/elements/1.1/"
                              xmlns:dcterms="http://purl.org/dc/terms/"
                              xmlns:dcmitype="http://purl.org/dc/dcmitype/"
                              xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
                              xmlns:o="urn:schemas-microsoft-com:office:office"
                              xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
                              xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
                              xmlns:v="urn:schemas-microsoft-com:vml"
                              xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
                              xmlns:w10="urn:schemas-microsoft-com:office:word"
                              xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
                              xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml" 
                              xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
                              xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
                              xmlns:rs="http://schemas.openxmlformats.org/package/2006/relationships"
                              xmlns:ps="http://www.pageseeder.com/editing/2.0"
                              xmlns:xs="http://www.w3.org/2001/XMLSchema"
                              exclude-result-prefixes="cp dc dcterms dcmitype ve o r m v wp w10 w wne pic a rs xs ps">
  
  <xsl:import href="openXML-to-ps.xsl"/>

	<xsl:param name="output-folder" />

  <xsl:template match="/">
    <responses>
      <xsl:apply-templates/>
    </responses>
  </xsl:template>
	
	<xsl:template match="w:footnotes">
		  <xsl:apply-templates mode="footnote" />
	</xsl:template>

	<xsl:template match="w:footnote" mode="footnote" >
		<xsl:variable name="fn-id" select="@w:id" />
		<!-- make sure process any footnotes id start from 1 -->
		<xsl:if test="number($fn-id) gt 0">
			<response><xsl:value-of select="$fn-id"/></response>
			
			<xsl:result-document href="{concat(replace($output-folder, '\\', '/'),'/footnotes/',$fn-id,'.xml')}">
				<xsl:processing-instruction name="stylesheet">
					<xsl:text>format="standard" config="footnote" title="</xsl:text>
					<xsl:value-of select="$fn-id"/>
					<xsl:text>"</xsl:text>
				</xsl:processing-instruction>
				<root>
					<properties>
						<property name="document-type">footnotes</property>
					</properties>
					<section id="title">
						<body>
							<heading1><xsl:value-of select="$fn-id"/></heading1>
						</body>
					</section>
					<section id="1">
						<body>
							<xsl:apply-templates select="w:p"/>
						</body>
					</section>
				</root>
			</xsl:result-document>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>