<?xml version="1.0"?>
<xsl:stylesheet version="2.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:saxon="http://saxon.sf.net/"
                xmlns:log="http://www.allette.com.au/log"
                exclude-result-prefixes="saxon log">

  <xsl:output encoding="UTF-8" method="xml" indent="no" />

    
  <xsl:template match="/">
    <xsl:apply-templates select="element()|text()|comment()|processing-instruction()"/>
  </xsl:template>

  <xsl:template match="attribute()|comment()|processing-instruction()">
    <xsl:copy>
      <xsl:apply-templates select="comment()|processing-instruction()"/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="element()">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>
  
  <!--comment ID: 302792, fixed mixed content-->
  <xsl:template match="item">
    <xsl:for-each-group select="node()" group-adjacent="if (self::list or self::nlist or self::para or self::block or self::table or self::blockXref) then 2 else 1">
        <item>
	        
	        <xsl:apply-templates select="current-group()"/>
        </item>
    </xsl:for-each-group>
  </xsl:template>
  
    <!--comment ID: 302792, fixed mixed content-->
    <xsl:template match="cell|hcell">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
	    <xsl:for-each-group select="node()" group-adjacent="if (self::list or self::nlist or self::para or self::block or self::table or self::blockXref) then 2 else 1">
	       
	       <xsl:choose>
	           <xsl:when test="current-grouping-key()=1">
	               <para><xsl:apply-templates select="current-group()"/></para>
	           </xsl:when>
	           <xsl:otherwise>
	               <xsl:apply-templates select="current-group()"/>
	           </xsl:otherwise>
	       </xsl:choose>
	    </xsl:for-each-group>
    </xsl:copy>
  </xsl:template>
 
 <!--comment ID: 302792, fixed mixed content-->
   <xsl:template match="block">
   <block>
        <xsl:copy-of select="@*"/>
        <xsl:for-each-group select="node()" group-adjacent="if (self::list or self::nlist or self::para or self::block or self::table or self::blockXref) then 2 else 1">
           
           <xsl:choose>
               <xsl:when test="current-grouping-key()=1">
                   <para><xsl:apply-templates select="current-group()"/></para>
               </xsl:when>
               <xsl:otherwise>
                   <xsl:apply-templates select="current-group()"/>
               </xsl:otherwise>
           </xsl:choose>
    </xsl:for-each-group>
    </block>
  </xsl:template>
 
 
 <!--
  <xsl:template match="item[para|paraLabel|list|nlist|mlist]">
  
    <xsl:if test="text()[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist]
                  or *[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']">
      <item>
        <xsl:apply-templates select="text()[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist]
                  | *[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']"/>
      </item>
    </xsl:if>
    <item><xsl:apply-templates select="*[name()='para' or name()='paraLabel' or name()='list' or name()='nlist' or name()='mlist']"/></item>
    <xsl:if test="text()[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist]
                  or *[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']">
      <item>
        <xsl:apply-templates select="text()[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist]
                  | *[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']"/> 
      </item>
    </xsl:if>
  </xsl:template>
  -->
  <!--
     <xsl:template match="cell[para|paraLabel|list|nlist|mlist]">
  <cell>
    <xsl:if test="text()[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist]
                  or *[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']">
      <para>
        <xsl:apply-templates select="text()[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist]
                  | *[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']"/>
      </para>
    </xsl:if>
    <xsl:apply-templates select="*[name()='para' or name()='paraLabel' or name()='list' or name()='nlist' or name()='mlist']"/>
    <xsl:if test="text()[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist]
                  or *[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']">
      <para>
        <xsl:apply-templates select="text()[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist]
                  | *[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']"/> 
      </para>
    </xsl:if>
    </cell>
  </xsl:template>-->

<!--
   <xsl:template match="paraLabel[para|paraLabel|list|nlist|mlist]">
    <xsl:if test="text()[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist]
                  or *[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']">
      <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates select="text()[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist]
                  | *[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']"/>
      </xsl:copy>
    </xsl:if>
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates select="*[name()='para' or name()='paraLabel' or name()='list' or name()='nlist' or name()='mlist']"/>
    </xsl:copy>
      
    <xsl:if test="text()[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist]
                  or *[following-sibling::para or following-sibling::paraLabel or following-sibling::list or following-sibling::nlist or following-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']">
      <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates select="text()[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist]
                  | *[preceding-sibling::para or preceding-sibling::paraLabel or preceding-sibling::list or preceding-sibling::nlist or preceding-sibling::mlist][name()!='para'][name()!='paraLabel'][name()!='list'][name()!='nlist'][name()!='mlist']"/> 
      </xsl:copy>
    </xsl:if>
  </xsl:template>-->

</xsl:stylesheet>
