<?xml version="1.0"?>
<!--
  Templates used to display the files for a project.

  @author Jean-Baptiste Reure
  @author Christophe Lauret
  @version 17 March 2011
-->
<xsl:stylesheet version="2.0" xmlns="http://www.w3.org/1999/xhtml"
                              xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:xs="http://www.w3.org/2001/XMLSchema"
                              xmlns:psf="http://www.pageseeder.com/function"
                              exclude-result-prefixes="xs psf">

<xsl:variable name="context-path" select="/root/header/context-path"/> 


  <!-- Main template -->
  <xsl:template match="content[@name = 'config'][@target = 'config']"/>
  <xsl:template match="content[@name = 'config'][@target = 'main']">
    <h2>Publisher Properties</h2>
    <table class="properties" cellspacing="0" cellpadding="0">
      <thead>
        <tr>
          <th>Property name</th>
          <th>Property value</th>
        </tr>
      </thead>
      <tbody>
        <xsl:for-each select="properties/property">
          <xsl:sort select="@name" />
          <tr class="property {if (position() mod 2 = 0) then 'even' else 'odd'}">
            <td class="name"><xsl:value-of select="@name" /></td>
            <td class="value"><xsl:value-of select="@value" /></td>
          </tr>
        </xsl:for-each>
      </tbody>
    </table>
    <div class="button">
      <a class="button" href="{../header/url}?berlioz-reload=true">Reload</a>
    </div>
  </xsl:template>
  
<!-- Main template OLD -->
<xsl:template match="content[@name = 'settings']">
  <h2>Publisher Properties</h2>
  <form action="{$context-path}/admin/settings/save.html" method="post">
    <div class="source">
      <!-- Only if it is editable -->
      <!-- xsl:if test="@editable ='true'" -->
        <textarea name="content" style="display: none"><xsl:value-of select="text()"/></textarea>
      <!-- /xsl:if -->
      <!-- non-standard class required by syntax highlighter -->
      <pre class="brush: properties; light: true;"><xsl:value-of select="text()"/></pre>
    </div>
    <!-- Only if it is editable -->
    <!--xsl:if test="@editable ='true'"-->
      <div class="buttons" style="display: none">
        <input name="submit" type="submit" value="Save" class="submit"/>
        <input name="cancel" type="reset" value="Cancel" class="button cancel"/>
      </div>
    <!--/xsl:if-->
  </form>
  <!-- syntax highlighting -->
  <script type="text/javascript" src="{$context-path}/js/lib/syntaxhighlighter/syntaxhighlighter.core.js"></script>
  <script type="text/javascript" src="{$context-path}/js/lib/syntaxhighlighter/syntaxhighlighter.brush.properties.js"></script>
  <script>var PublisherContext = '<xsl:value-of select="$context-path" />';</script>
</xsl:template>
  
</xsl:stylesheet>
