/**
 * Behaviour of the resource view page
 * 
 * @author Christophe Lauret
 * @version 26 October 2010
 */

// Declare all global dependencies for JSLint
/*global PAGESEEDER, $ */

// Defines and invokes an anonymous function to create a closure.
$(document).ready(function() {
  
  // Syntax highlighter configuration
  SyntaxHighlighter.defaults.gutter = false;
  SyntaxHighlighter.defaults.toolbar = false;
  SyntaxHighlighter.all();
  
  var jsessionid = $('#jsessionid').attr('value');
  $('.source').dblclick(function() {
     $('.syntaxhighlighter').hide();
     $('.source textarea').show();
     $('.buttons').show();
  });
  $('.cancel').click(function() {
     $('.syntaxhighlighter').show();
     $('.source textarea').hide();
     $('.buttons').hide();
  });

  $('.submit').click(function() {
    var $form = $(this).closest('form');
    var location = $form.find('input[name=location]').val();
    var content = $form.find('textarea[name=content]').val();
    $.ajax({
      type: "POST",
      url: PublisherContext + '/admin/settings/save.xml',
      data: {'location' : location, 'content' : content, 'overwrite' : 'true', 'jsessionid': jsessionid},
      complete: function(xhr, textStatus) {
        if (xhr.status >= 400) {
          alert($(xhr.responseXML).find('message').text());
        } else {
          var $f = $(xhr.responseXML).find('settings');
          $('.source .syntaxhighlighter').remove();
          var $code = $('<pre class="brush: properties; light: true;">');
          $code.text($f.text());
          $('.source').append($code);
          $('.syntaxhighlighter').show();
          $('.source textarea').hide();
          $('.buttons').hide();
          SyntaxHighlighter.highlight();
        }
      }
    });
    return false;
  });

});
